<?php

/*  
	Copyright
	----------
	
	mLanguage2009 by Gnomx.at.
	
    This file is part of InfoLink.

    mLanguage is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mLanguage is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with mLanguage.  If not, see <http://www.gnu.org/licenses/>.
*/


function mlang_config_menu() 
{
    add_options_page("mLang", "mLanguage", 8, __FILE__, "mlang_menu_page");
}

function arr_del($a, $val) {
	
	for($i=0;$i<count($a);++$i)
	{
		if($a[$i]['lang'] == $val)
		unset($a[$i]);
	}
	sort($a);
    return $a;
}

function mlang_setdef_lang($array, $newdef)
{	
	for ($i=0;$i<count($array);$i++)
	{
		if($newdef == $array[$i]['lang'] )
		{
			$array[$i]['default'] = 1;
		}
		else
		{
			$array[$i]['default'] = 0;
		}
	}
	return $array;
}

function mlang_menu_page()
{	
	
	
	$hidden_field_name = "mt_submit_hidden";
	$lang_field_name = "mt_submit_lang";
	$default_checker_name = "mt_submit_default";
	$title_field_name = "mt_submit_title";
	$feed_checker_name = "mt_submit_feed";
	$feednote_checker_name = "mt_submit_feednote";
	$menutitle_checker_name = "mt_submit_smtitle";
	
    //Get Options
	
	
	$langArray = array(
		0 => array ( 'lang' => 'en',
				 	 'default' => '1',
				 	 'title' => 'English',
					 'img' => 'en',
					 'feed' => 'true',
					 'feednote' => '1',
					 'showtitle' => '0',
					 'rdir' => 'LTR'),
		1 => array ( 'lang' => 'de',
				 	 'default' => '0',
				 	 'title' => 'Deutsch',
					 'img' => 'de-at',
					 'feed' => 'false',
					 'feednote' => '1',
					 'showtitle' => '0',
					 'rdir' => 'LTR'));
	
	$la = get_option("mlang_lang");
	
	if(empty($la))
	{
		add_option("mlang_lang",$langArray);
		$a = $defLang;
	} else {
	$langArray = $la;	
	}
	
	
	
	if( $_REQUEST['action'] == 'delete')
	{
		$dlang = $_REQUEST['lang'];
		
		foreach($langArray as $key)
		{
			if($key['lang'] == $dlang){
				$langArray = arr_del($langArray, $key['lang']);
			?><div class="updated"><p><strong><?php _e('Language '.$dlang.' deleted.', 'mlang' ); ?></strong></p></div> <?php
			}
		}
	
		update_option("mlang_lang", $langArray );
		
	} 
	
	if($_REQUEST['action'] == 'edit')
	{
		$elang = $_REQUEST['lang'];
		foreach($langArray as $key)
		{
			if($key['lang'] == $elang)
			{
				$edef = $key['default'];
				$etitle = $key['title'];
				$efeed = $key['feed'];
				if(!isset($key['feednote']))
					$efeednote = 1;
				else
					$efeednote = $key['feednote'];
				
				$esmtitle = $key['showtitle'];
				
				if(isset($key['img']))
							$eimg = $key['img'];						
						else
							$eimg = $key['lang'];
						
				if(!isset($key['rdir']))
					$ereaddir = 'LTR';
				else
					$ereaddir = $key['rdir'];
				
			}
		}
	}
	
	if( $_POST[ $hidden_field_name ] == 'U' ) {
		$lang = $_POST[ $lang_field_name ];
		$def =  $_POST[ $default_checker_name ] or 0;
		$title = $_POST[ $title_field_name ];
		$flag = $_POST[ 'flag_option' ];
		$feed = $_POST[ $feed_checker_name ] or false;
		$feednote = $_POST[ $feednote_checker_name ];
		$smtitle = $_POST[ $menutitle_checker_name ];
		$readdir = $_POST[ 'lang_read_dir' ];
		
		if(!isset($feednote)) $feednote = 0;
		
		
		if(isset($title)){
			
			for ($i=0;$i<count($langArray);$i++)
			{
				if($lang == $langArray[$i]['lang'] )
				{
					$langArray[$i]['title'] = $title;
					if($def == 1) $langArray = mlang_setdef_lang($langArray, $lang);
					else $langArray[$i]['default'] = 0;
					$langArray[$i]['img'] = $flag;
					$langArray[$i]['feed'] = $feed;
					$langArray[$i]['feednote'] = $feednote;
					$langArray[$i]['showtitle'] = $smtitle;
					$langArray[$i]['rdir'] = $readdir;
				}
			}
			
			$defset = 0;
			foreach($langArray as $i)
			{
				if($i['default'] == 1)
				{
					$defset = $defset + 1;
				}
			}
			
			if($defset == 1)
			{
				update_option("mlang_lang", $langArray);
				?>
				<div class="updated"><p><strong><?php _e('Tag Updated.', 'mlang' ); ?></strong></p></div>
			<?php
			} else {
			?><div class="error"><p><strong><?php _e('There is no or to many default Language(s) defined. Please define one.', 'mlang' ); ?></strong></p></div><?php
			}
		}
	}
	if( $_POST[ $hidden_field_name ] == 'Y' ) {
		$lang = $_POST[ $lang_field_name ];
		$def =  $_POST[ $default_checker_name ] or 0;
		$title = $_POST[ $title_field_name ];
		$feed = $_POST[ $feed_checker_name ];
		$feednote = $_POST[ $feednote_checker_name ];
		$smtitle = $_POST[ $menutitle_checker_name ];
		$readdir = $_POST[ 'lang_read_dir' ];
		
		if(!isset($feednote)) $feednote = 0;
		
		if(!isset($readdir)) $readdir = 'LTR';
		
		if(!empty($lang) && !empty($title)){
		$newEntry = array(
						'lang' => $lang,
				 	 	'default' => $def,
				 	 	'title' => $title,
						'img' => $lang,
						'feed' => $feed,
						'feednote' =>$feednote,
						'showtitle' => $smtitle,
						'rdir' => $readdir);
		$save = true;
		foreach($langArray as $a)
		{
			if($a['lang'] == $lang){
				$save = false;
				break;
			}
		}
		if($save){
			array_push($langArray,$newEntry);
			
			if($def == 1) $langArray = mlang_setdef_lang($langArray, $lang);
			
			update_option("mlang_lang", $langArray );


		?>
			<div class="updated"><p><strong><?php _e('Options saved.', 'mlang' ); ?></strong></p></div>
		<?php
		} else { ?>
        	<div class="error"><p><strong><?php _e('There is already a Language with that Tag.', 'mlang' ); ?></strong></p></div>
        <?php
		}
    } else { ?>
    	<div class="error"><p><strong><?php _e('You must define Language Name and Tag.', 'mlang' ); ?></strong></p></div>
    <?php
	}
	}
	?>
    <div class="wrap">
    <h2>WP mLanguage Options</h2>
    <p>
    	<?php if($_REQUEST['action'] == 'edit') _e("<span style=\"text-align:left\"><a href=\"?page=mlanguage/options.php\" title=\"Add New Tag\">Add New Language Tag</a></span>"); ?>
    	<table class="widefat" style="margin-top:4px;" width="300px">
        <thead>
        	<tr>
            	<th scope="col" width="180px">Language</th>
                <th scope="col" style="text-align:center" width="25px">Default</th>
                <th scope="col" style="text-align:center" width="35px">Tag</th>
                <th scope="col" style="text-align:center" width="10px">T. Dir.</th>
                <th scope="col" style="text-align:center" width="35px">Flag</th>
                <th scope="col" style="text-align:center" width="35px">Feed</th>
                <th scope="col" style="text-align:center" width="50px">Actions</th>
            </tr>
        </thead>
        <tbody id="the-list">
        <?php
        	foreach($langArray as $a)
			{	
				if(isset($a)){
				$d = 0;
				$f = 0;
				if(isset($a['img']))
						{ 
							$img = $a['img'];
						}
						else
						{
							$img = $a['lang'];
							$a['img'] = $img;
						}
				if($a['default']==1) $d = x;
				if($a['feed']) $f = x;
				if(isset($a['rdir']))
					$tdir = $a['rdir'];
				else
					$tdir = 'LTR';
					
				echo"<tr class=\"alternate\">
					  <td style=\"text-align:left;\" width=\"145px\" >".$a['title']."</td>
					  <td style=\"text-align:center;\" width=\"25px\" >".$d."</td>
					  <td style=\"text-align:center;\" width=\"35px\">".$a['lang']."</td>
					  <td style=\"text-align:center;\" width=\"10px\">".$tdir."</td>
					  <td style=\"text-align:center;\" width=\"35px\"><img src=\"".WPMLANG_PLUGIN_URL."/img/".$img.".png\" title=\"Flag\" /></td>
					  <td style=\"text-align:center;\" width=\"35px\" >".$f."</td>
					  <td style=\"text-align:center;\" width=\"50px\"><a href=\"?page=mlanguage/options.php&action=edit&lang=".$a['lang']."\" title=\"Edit\">Edit</a>&nbsp;&brvbar;&nbsp;<a href=\"?page=mlanguage/options.php&action=delete&lang=".$a['lang']."\" title=\"Delete\">Delete</a></td>
				</tr>";	
				}
			} 
		?>
        </tbody>
        </table>
    </p>
    <p>
     <fieldset style="border:solid 1px #888; margin-top:20px; padding-left:10px;">
    <legend style="margin:-10px 5px 0 0"><h3><?php if($_REQUEST['action'] == 'edit')_e('Edit Language', 'mlang' ); else _e('Add Language', 'mlang' );?></h3></legend>
    <form style="margin-top:5px;" name="form1" method="post" action="?page=mlanguage/options.php">
    <input type="hidden" name="<?php echo $hidden_field_name; ?>" value="<?php if($_REQUEST['action'] == 'edit') echo"U"; else echo"Y"; ?>" />
     <p>
    <label title="Language Name"><b>Language Name</b></label><br />
    <input type="text" name="<?php echo $title_field_name; ?>" value="<?php if($_REQUEST['action'] == 'edit') echo $etitle; else echo""; ?>" />
    </p>
    <p>
    <label><b>Language Tag (Language Code)</b></label><br />
    <input type="text" maxlength="2" name="<?php echo $lang_field_name; ?>"  value="<?php if($_REQUEST['action'] == 'edit') echo $elang.'" readonly="readonly"'; else echo""; ?>" /><small><a href="http://babelwiki.babelzilla.org/index.php?title=Language_codes" title="Language Codes">Code(Tag) List</a></small></p>
    <p>
    <label><input type="checkbox" name="<?php echo $default_checker_name; ?>" value="1" <?php if($_REQUEST['action'] == 'edit') { if($edef == 1) echo'checked=\"checked\"'; } ?> />&nbsp;<b>Default Language</b>.</label></p>
    <p>
    <label><b>Direction of Text</b></label><br />
    <label>LeftToRight:<input type="radio" name="lang_read_dir" id="lang_read_dir1" value="LTR" <?php if($ereaddir == 'LTR') echo'checked="checked"'; ?> /></label>&nbsp;<label>RightToLeft:<input type="radio" name="lang_read_dir" id="lang_read_dir2" value="RTL" <?php if($ereaddir == 'RTL') echo'checked="checked"'; ?> /></label>&nbsp;
    </p>
    <p>
    <label><input type="checkbox" name="<?php echo $feed_checker_name; ?>" value="1" <?php if($_REQUEST['action'] == 'edit') { if($efeed) echo'checked=\"checked\"'; } ?> />&nbsp;<b>Create Feed</b>.</label><br />
    <label><input type="checkbox" title="Creates a Note under every post in which language this article is also available." name="<?php echo $feednote_checker_name; ?>" value="1" <?php if($_REQUEST['action'] == 'edit') { if($efeednote == 1) echo'checked=\"checked\"'; } ?> />&nbsp;<b>Feednote</b>.</label></p>
    <p>
    <label><input type="checkbox" name="<?php echo $menutitle_checker_name; ?>" value="1" <?php if($_REQUEST['action'] == 'edit') { if($esmtitle == 1) echo'checked=\"checked\"'; } ?> />&nbsp;<b>Show Language Name in Menu</b>.</label><br /></p>
    <?php 
	if($_REQUEST['action'] == 'edit') {
		echo "<p><label><b>Flag:</b></label><br />";
		if ($handle = opendir(WPMLANG_PLUGIN_DIR . '/img/')) 
		{
			$count = 0;
		
			while (false !== ($file = readdir($handle))) 
			{
				$fname = str_replace('.png', '', $file);
				if($fname == $elang || substr($fname, 0, 3) == $elang."-")
				{
					?>
                    <label><img src="<?php echo WPMLANG_PLUGIN_URL."/img/".$file; ?>" title="<?php echo $fname; ?>"/><input type="radio" name="flag_option" id="flag_opion_<?php echo $count; ?>" value="<?php  echo $fname; ?>" <?php if($fname == $eimg) echo'checked="checked"'; ?> /></label>&nbsp;
                    <?php
					$count++;
				}
			}
			closedir($handle);
		}
		echo "</p>";
	} 
	?>
    
    <p class="submit">
	<input type="submit" name="Submit" value="<?php if($_REQUEST['action'] == 'edit') _e('Update Tag', 'mlang' );  else _e('Add Tag', 'mlang' ); ?>" />
	</p>
    </form>
    </fieldset>
    </p>
    <br />
    <h2>How to use?</h2>
    <p>You have only to write post, tagging each language:</p>
<p style="font-style:italic">
eg. [de]Deutsch[/de] [en]English[/en]
</p>
<p>
For <b>titles</b>, you have to write as normal title inside post, the one in the language you have set as default.
</p>
Then you have only to scroll till Custom Fields and add:
<p>key: the short tag of the language ( the two first letters of the Language Code eg. de, en, fr )<br />
value: the title text.</p>
<hr />
<small style="color:#999">Need help? FAQ, Usage instructions and other notes can be found on the plugin page <a href="http://www.gnomx.at/mlang">here.</a></small>
    </div>
    <?php
}

add_action("admin_menu","mlang_config_menu"); 
?>